__gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc > Class Template Reference

`#include <node_iterators.hpp>`

Inheritance diagram for __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >:
[legend]

## Public Types

typedef _Alloc::template rebind< typenameremove_const< Value_Type >::type >::other::const_pointer | const_reference
typedef trivial_iterator_difference_type | difference_type
typedef trivial_iterator_tag | iterator_category
typedef _Alloc::template rebind< metadata_type >::other::const_reference | metadata_const_reference
typedef Metadata_Type | metadata_type
typedef _Alloc::template rebind< typenameremove_const< Value_Type >::type >::other::const_pointer | reference
typedef _Alloc::template rebind< Value_Type >::other::const_pointer | value_type

## Public Member Functions

| ov_tree_node_const_it_ (const_pointer p_nd=0, const_pointer p_begin_nd=0, const_pointer p_end_nd=0, const_metadata_pointer p_metadata=0)
this_type | get_l_child () const
metadata_const_reference | get_metadata () const
this_type | get_r_child () const
bool | operator!= (const this_type &other) const
const_reference | operator* () const
bool | operator== (const this_type &other) const

## Public Attributes

pointer | m_p_begin_value
pointer | m_p_end_value
const_metadata_pointer | m_p_metadata
pointer | m_p_value

## Protected Types

typedef _Alloc::template rebind< Metadata_Type >::other::const_pointer | const_metadata_pointer
typedef _Alloc::template rebind< Value_Type >::other::const_pointer | const_pointer
typedef _Alloc::template rebind< Value_Type >::other::pointer | pointer
typedef ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc > | this_type

## Static Protected Member Functions

template<typename Ptr >
static Ptr | mid_pointer (Ptr p_begin, Ptr p_end)

## Detailed Description

template<typename Value_Type, typename Metadata_Type, typename _Alloc>
class __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >

Const node reference.

Definition at line 57 of file ov_tree_map_/node_iterators.hpp.

## Member Typedef Documentation

## const_metadata_pointer

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

typedef _Alloc::template rebind<Metadata_Type>::other::const_pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::const_metadata_pointer

protected

Definition at line 74 of file ov_tree_map_/node_iterators.hpp.

## const_pointer

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

typedef _Alloc::template rebind<Value_Type>::other::const_pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::const_pointer

protected

Definition at line 69 of file ov_tree_map_/node_iterators.hpp.

## const_reference

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

typedef _Alloc::template rebind<typenameremove_const<Value_Type>::type>::other::const_pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::const_reference

Definition at line 109 of file ov_tree_map_/node_iterators.hpp.

## difference_type

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

typedef trivial_iterator_difference_type __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::difference_type

Definition at line 92 of file ov_tree_map_/node_iterators.hpp.

## iterator_category

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

typedef trivial_iterator_tag __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::iterator_category

Definition at line 90 of file ov_tree_map_/node_iterators.hpp.

## metadata_const_reference

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

typedef _Alloc::template rebind<metadata_type>::other::const_reference __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::metadata_const_reference

Definition at line 116 of file ov_tree_map_/node_iterators.hpp.

## metadata_type

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

typedef Metadata_Type __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::metadata_type

Definition at line 111 of file ov_tree_map_/node_iterators.hpp.

## pointer

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

typedef _Alloc::template rebind<Value_Type>::other::pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::pointer

protected

Definition at line 64 of file ov_tree_map_/node_iterators.hpp.

## reference

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

typedef _Alloc::template rebind<typenameremove_const<Value_Type>::type>::other::const_pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::reference

Definition at line 103 of file ov_tree_map_/node_iterators.hpp.

## this_type

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

typedef ov_tree_node_const_it_<Value_Type, Metadata_Type, _Alloc> __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::this_type

protected

Definition at line 76 of file ov_tree_map_/node_iterators.hpp.

## value_type

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

typedef _Alloc::template rebind<Value_Type>::other::const_pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::value_type

Definition at line 97 of file ov_tree_map_/node_iterators.hpp.

## Constructor & Destructor Documentation

## ov_tree_node_const_it_()

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

__gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::ov_tree_node_const_it_ | ( | const_pointer | p_nd = `0`,
|  | const_pointer | p_begin_nd = `0`,
|  | const_pointer | p_end_nd = `0`,
|  | const_metadata_pointer | p_metadata = `0`
| ) |  |

inline

Definition at line 120 of file ov_tree_map_/node_iterators.hpp.

## Member Function Documentation

## get_l_child()

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

this_type __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::get_l_child | ( |  | ) | const

inline

Returns the node iterator associated with the left node.

Definition at line 142 of file ov_tree_map_/node_iterators.hpp.

## get_metadata()

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

metadata_const_reference __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::get_metadata | ( |  | ) | const

inline

Definition at line 128 of file ov_tree_map_/node_iterators.hpp.

## get_r_child()

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

this_type __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::get_r_child | ( |  | ) | const

inline

Returns the node iterator associated with the right node.

Definition at line 158 of file ov_tree_map_/node_iterators.hpp.

## mid_pointer()

template<typename Value_Type , typename Metadata_Type , typename _Alloc >
template<typename Ptr >

static Ptr __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::mid_pointer | ( | Ptr | p_begin,
|  | Ptr | p_end
| ) |  |

inline static protected

Definition at line 82 of file ov_tree_map_/node_iterators.hpp.

## operator!=()

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

bool __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::operator!= | ( | const this_type & | other | ) | const

inline

Definition at line 188 of file ov_tree_map_/node_iterators.hpp.

## operator*()

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

const_reference __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::operator* | ( |  | ) | const

inline

Definition at line 124 of file ov_tree_map_/node_iterators.hpp.

## operator==()

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

bool __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::operator== | ( | const this_type & | other | ) | const

inline

Definition at line 173 of file ov_tree_map_/node_iterators.hpp.

## Member Data Documentation

## m_p_begin_value

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::m_p_begin_value

Definition at line 193 of file ov_tree_map_/node_iterators.hpp.

## m_p_end_value

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::m_p_end_value

Definition at line 194 of file ov_tree_map_/node_iterators.hpp.

## m_p_metadata

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

const_metadata_pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::m_p_metadata

Definition at line 196 of file ov_tree_map_/node_iterators.hpp.

## m_p_value

template<typename Value_Type , typename Metadata_Type , typename _Alloc >

pointer __gnu_pbds::detail::ov_tree_node_const_it_< Value_Type, Metadata_Type, _Alloc >::m_p_value

Definition at line 192 of file ov_tree_map_/node_iterators.hpp.

The documentation for this class was generated from the following file:

- ov_tree_map_/node_iterators.hpp